<?php
/**
 * copyright (C) 2008 GWE Systems Ltd - All rights reserved
 */

defined( 'JPATH_BASE' ) or die( 'Direct Access to this location is not allowed.' );

use Joomla\CMS\MVC\Controller\BaseController;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Factory;
use Joomla\CMS\Filesystem\Folder;

jimport('joomla.application.component.controller');
jimport('joomla.filesystem.folder');
class AdminCpanelController extends BaseController {
	/**
	 * Controler for the Control Panel
	 * @param array		configuration
	 */
	function __construct($config = array())
	{
		parent::__construct($config);
		$this->registerTask( 'show',  'cpanel' );
		$this->registerDefaultTask("cpanel");


		// setup filesystem for images
		$this->_checkFilesystem();

	}

	function cpanel( )
	{
		// get the view
		$this->view = $this->getView("cpanel","html");

		if (file_exists(JPATH_ADMINISTRATOR."/components/com_jevlocations/install.php")){
			include_once(JPATH_ADMINISTRATOR."/components/com_jevlocations/install.php");
			$installer = new com_jevlocationsInstallerScript();
			$installer->update(false);
		}

		// Detect old Falang and JoomFish translations
		if (file_exists(JPATH_ADMINISTRATOR."/components/com_falang/contentelements/jevlocations_categories.xml")){
			$falangMessage = Text::_("COM_JEVLOCATIONS_FALANG_WARNING");
			Factory::getApplication()->enqueueMessage($falangMessage, 'warning');
		}


		// Set the layout
		$this->view->setLayout('cpanel');
		$this->viewtitle =  Text::_("COM_JEVLOCATIONS_ADMIN_CPANEL");

		$this->view->display();
	}

	function _checkFilesystem(){
		// folder relative to media folder
		$folder = "jevents/jevlocations";
		// ensure folder exists
		if (!Folder::exists(JPATH_ROOT.'/images/stories/'.$folder)) {
			Folder::create(JPATH_ROOT. '/images/stories/'.$folder);
		}
	}

}
