<?php
/**
 * JEvents Locations Component for Joomla 1.5.x
 *
 * @version     $Id$
 * @package     JEvents
 * @copyright   Copyright (C) 2008-2009 GWE Systems Ltd
 * @license     GNU/GPLv2, see http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://www.jevents.net
 */

// Check to ensure this file is included in Joomla!

defined('JPATH_BASE') or die;

use Joomla\Registry\Registry;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Form\FormHelper;
use Joomla\CMS\Factory;

jimport('joomla.html.html');
jimport('joomla.form.formfield');
jimport('joomla.form.helper');
FormHelper::loadFieldClass('radio');

/**
 * JEVMenu Field class for the JEvents Component
 *
 * @package		JEvents.fields
 * @subpackage	com_banners
 * @since		1.6
 */
class JFormFieldJEVBoolean extends JFormFieldRadio
{
	/**
	 * The form field type.s
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'JEVBoolean';

	/**
	 * Method to get the field options.
	 *
	 * @return	array	The field option objects.
	 * @since	1.6
	 */
	public function getOptions()
	{		
		// Must load admin language files
		$lang = Factory::getLanguage();
		$lang->load("com_jevents", JPATH_ADMINISTRATOR);
		$lang->load("plg_jevents_jevlocations", JPATH_ADMINISTRATOR);

		// do we need to merge the plugin parameters?
		if ($this->form->getValue("gwidth",null, -1)==-1){
			$plugin = PluginHelper::getPlugin("jevents","jevlocations");
			if ($plugin){
				$pluginparams = new Registry($plugin->params);
				$this->form->bind($pluginparams);
			}
		}
		
		$options = array ();
		$options[] = JHTML::_('select.option', 0, Text::_("Jev_No"));
		$options[] = JHTML::_('select.option', 1, Text::_("jev_Yes"));

		return $options;

		
	}
}
