var myGeocoder = null;
var googleaddress = null;
var geodata = null;
var skipGeoLookup = false;

function findAddressGeo(eventObj, submit) {
	skipGeoLookup = false;
	if (typeof geomapsprovider == "undefined" || geomapsprovider == "googlemaps") {
		findAddressGeoGoogle(eventObj, submit);
	}
	else {
		findAddressGeoOsm(eventObj, submit);
	}
}

function findAddressGeoGoogle(eventObj, submit) {
	geodata = new Array();
	$googleaddress = jQuery("#googleaddress");
	if ($googleaddress.length > 0) {
		googleaddress = $googleaddress.val()
	}

	if (!googleaddress || googleaddress.length == 0) {
		// uncomment to make compulsary
		// alert("Please enter an address and/or zip code");
		return false;
	}
	if (myGeocoder) {
		var myTimer = trapSlowGeocoder.delay(3000);

		myGeocoder.geocode({
				'address': googleaddress,
				'region': jQuery('#gregion').val()
			},
			function (results, status) {
				var $gaddressmatches = jQuery("#gaddressmatches");
				$gaddressmatches.html("");
				$gaddressmatches.css('display', "none");

				if (status == google.maps.GeocoderStatus.OK) {
					if (results.length > 1) {
						submit = false;
						var countmatches = 0;
						for (var r = 0; r < results.length; r++) {
							match = results[r];
							geodata.push(match);
							$gaddressmatches.html($gaddressmatches.html() + "<a href='#select' onclick='setGeoData(" + countmatches + ")'>" + match.formatted_address + "</a><br/>");
							$gaddressmatches.css('display', "block");
							countmatches++;
						}
						;
					}
					else {
						jQuery("#googleaddress").val(results[0].formatted_address);
					}
					var $gvelem = jQuery("#geosearch_fv");
					if ($gvelem.length == 0)
					{
						$gvelem = jQuery("#browserlocationsearch_fv");
					}
					var point = results[0].geometry.location;
					//gvelem.value = point.lng()+","+point.lat();
					$gvelem.val(point.lat() + "," + point.lng());

					clearTimeout(myTimer);
					// since we stopped the event we must now allow the form to submit !!!
					if (submit) {
						$myform = jQuery("#jeventspost");
						$myform.submit();
					}
				} else {
					alert("Address/Zip Code " + googleaddress + " not found.");
					skipGeoLookup = true;
				}
			});
	}
}

function findAddressGeoOsm(eventObj, submit) {
	geodata = new Array();
	$googleaddress = jQuery("#googleaddress");
	if ($googleaddress.length > 0) {
		googleaddress = $googleaddress.val()
	}

	if (!googleaddress || googleaddress.length == 0) {
		// uncomment to make compulsary
		// alert("Please enter an address and/or zip code");
		return false;
	}
	var myTimer = trapSlowGeocoder.delay(3000);

	var url = "//open.mapquestapi.com/nominatim/v1/search.php?key=" + mapquestkey + "&format=json&q=" + encodeURI(googleaddress) + "&addressdetails=1&limit=3";

	const xhr = new XMLHttpRequest();
	xhr.open("GET", url);

	xhr.onload = function () {
		try {
			if (xhr.status != 200) {
				alert('error ' + xhr.statusText);
				return;
			}

			let returnData = JSON.parse(xhr.responseText);
			console.log(returnData);

			var $gaddressmatches = jQuery("#gaddressmatches");
			$gaddressmatches.html("");
			$gaddressmatches.css('display', "none");

			if (typeof returnData.error == 'undefined' && returnData.length) {
				if (returnData.length > 1) {
					submit = false;
					var countmatches = 0;
					for (var r = 0; r < returnData.length; r++) {
						match = returnData[r];
						geodata.push(match);
						$gaddressmatches.html($gaddressmatches.html() + "<a href='#select' onclick='setGeoData(" + countmatches + ")'>" + match.display_name + "</a><br/>");
						$gaddressmatches.css('display', "block");
						countmatches++;
					}
					;
				}
				else {
					jQuery("#googleaddress").val(returnData[0].display_name);
				}

				clearTimeout(myTimer);
			} else {
				alert("Address/Zip Code " + googleaddress + " not found.");
				skipGeoLookup = true;
			}

		} catch (e) {
			alert('bad response = ' + e + "\n" + xhr.responseText );
		}
	}

	xhr.onerror = function () {
		alert('error ' + xhr.statusText);

	}

	xhr.send();

	return;


}

function setGeoData(idx) {
	var $gvelem = jQuery("#geosearch_fv");
	if ($gvelem.length == 0)
	{
		$gvelem = jQuery("#browserlocationsearch_fv");
	}
	if (typeof geomapsprovider == "undefined" || geomapsprovider == "googlemaps") {
		jQuery("#googleaddress").val(geodata[idx].formatted_address);
		var point = geodata[idx].geometry.location;
		$gvelem.val(point.lat() + "," + point.lng());
	}
	else
	{
		jQuery("#googleaddress").val(geodata[idx].display_name);
		$gvelem.val(geodata[idx].lat + "," + geodata[idx].lon);
	}

	var $gaddressmatches = jQuery("#gaddressmatches");
	$gaddressmatches.html("");
	$gaddressmatches.css('display', "none");

	$myform = jQuery("#jeventspost");
	$myform.submit();
}

function findEditAddressGeo(eventObj, submit) {
	var $gvelem = jQuery("#geosearch_fv");
	if ($gvelem.length == 0)
	{
		$gvelem = jQuery("#browserlocationsearch_fv");
	}
	if ($gvelem.length > 0) {
		//Do not get the geo location if already have it !!!
		return;
	}

	geodata = new Array();
	googleeditaddress = document.getElementById("evlocation");
	if (googleeditaddress) {
		googleeditaddress = googleeditaddress.value
	}
	if (!googleeditaddress || googleeditaddress.length == 0) {
		// uncomment to make compulsary
		// alert("Please enter an address and/or zip code");
		return false;
	}
	if (myGeocoder) {
		var myTimer = trapSlowGeocoder.delay(3000);

		myGeocoder.geocode({
				'address': googleeditaddress,
				'region': jQuery('#gregion').val()
			},
			function (results, status) {
				var gaddressmatches = jQuery("#geditaddressmatches");
				gaddressmatches.html("");
				gaddressmatches.css('display', "none");
				if (status == google.maps.GeocoderStatus.OK) {
					if (results.length > 1) {
						submit = false;
						var countmatches = 0;
						for (var r = 0; r < results.length; r++) {
							match = results[r];
							geodata.push(match);
							gaddressmatches.html(gaddressmatches.html() + "<a href='#select' onclick='setEditGeoData(" + countmatches + ")'>" + match.formatted_address + "</a><br/>");
							gaddressmatches.css('display', "block");
							countmatches++;
						}
						;
					}
					else {
						jQuery("#evlocation").val(results[0].formatted_address);
					}

					clearTimeout(myTimer);

				} else {
					alert("Address/Zip Code " + googleeditaddress + " not found.");
				}
			});

	}
}

function setEditGeoData(idx) {
	jQuery("#googleeditaddress").val(geodata[idx].formatted_address);
	var gaddressmatches = jQuery("#geditaddressmatches");
	gaddressmatches.html("");
	gaddressmatches.css("display", "none");
}

function trapSlowGeocoder() {
	alert("The address lookup is taking too long and so the address filter has been ignored");
	skipGeoLookup = true;
	$myform = jQuery("#jeventspost");
	$myform.submit();
}

function clearlonlat() {
	var $gvelem = jQuery("#geosearch_fv");
	if ($gvelem.length == 0)
	{
		$gvelem = jQuery("#browserlocationsearch_fv");
	}
	if ($gvelem.length > 0) {
		$gvelem.val("");
	}
}


function successLocation(position) {
	var googleaddress = document.getElementById("googleaddress");
	if (!googleaddress || googleaddress.value != "") {
		return;
	}

	var $gvelem = jQuery("#geosearch_fv");
	var $bvelem = jQuery("#browserlocationsearch_fv");
	if ($gvelem.length == 0 && $bvelem.length == 0) {
		return;
	}
	if ($gvelem.length > 0 && $bvelem.length > 0)
	{
		alert('Do not enable GeoFilter And BrowserLocationFilter in the same web page');
		return;
	}
	if ($gvelem.length > 0)
	{
		$gvelem.val(position.coords.latitude + "," + position.coords.longitude);
	}
	if ($bvelem.length > 0)
	{
		$bvelem.val(position.coords.latitude + "," + position.coords.longitude);
		$myform = jQuery("#jeventspost");
		$myform.submit();
		return;
	}
	if (typeof geomapsprovider == "undefined" || geomapsprovider == "googlemaps") {
		if (myGeocoder) {
			var myTimer = trapSlowGeocoder.delay(30000);

			var input = $gvelem.val();
			var latlngStr = input.split(",", 2);
			var lat = parseFloat(latlngStr[0]);
			var lng = parseFloat(latlngStr[1]);

			var latlng = new google.maps.LatLng(lat, lng);

			myGeocoder.geocode(
				{
					'latLng': latlng
				},
				function (results, status) {
					var $gaddressmatches = jQuery("#gaddressmatches");
					$gaddressmatches.html("");
					$gaddressmatches.css('display', "none");
					if (status == google.maps.GeocoderStatus.OK) {
						if (results.length > 0) {
							jQuery("#googleaddress").val(results[0].formatted_address);
							var point = results[0].geometry.location;
							$gvelem.val(point.lat() + "," + point.lng());
						}

						clearTimeout(myTimer);
						$myform = jQuery("#jeventspost");
						$myform.submit();
					} else {
						alert("Geocoder failed due to: " + status);
						$myform = jQuery("#jeventspost");
						$myform.submit();
					}
				}
			);
		}
	}
	else
	{
		var myTimer = trapSlowGeocoder.delay(30000);

		var input = $gvelem.val();
		var latlngStr = input.split(",", 2);
		var lat = parseFloat(latlngStr[0]);
		var lon = parseFloat(latlngStr[1]);

		var url = "//open.mapquestapi.com/nominatim/v1/reverse.php?key=" + mapquestkey + "&format=json&lat=" + lat + "&lon=" + lon + "&limit=1";

		const xhr = new XMLHttpRequest();
		xhr.open("GET", url);

		xhr.onload = function () {
			try {
				if (xhr.status != 200) {
					alert('error ' + xhr.statusText);
					return;
				}

				let returnData = JSON.parse(xhr.responseText);
				console.log(returnData);

				if (typeof returnData.error == 'undefined') {
					var point = new L.LatLng(returnData.lat, returnData.lon);

					jQuery("#googleaddress").val(returnData.display_name);
					$gvelem.val(returnData.lat + "," + returnData.lon);
				}
				else
				{
					alert("Location Lookup Failed" );
				}
				clearTimeout(myTimer);
				$myform = jQuery("#jeventspost");
				$myform.submit();

			} catch (e) {
				alert('bad response = ' + e + "\n" + xhr.responseText );
			}
		}

		xhr.onerror = function () {
			alert('error ' + xhr.statusText);

		}

		xhr.send();

		return;
	}
}

function failureLocation(geolocationerror) {
	errorCode = geolocationerror.code;
	errorMessage = geolocationerror.message;
	//alert(errorCode + " : " + errorMessage);
}

function findEventNearby(autogeolocate) {
	errorCode = autogeolocate.code;
	errorMessage = autogeolocate.message;

	// Touch devices only
	if (autogeolocate == 2) {
		try {
			document.createEvent("TouchEvent");
		}
		catch (e) {
			return false;
		}
	}
	// no need to auto-locate if we have already done so!
	var $bvelem = jQuery("#browserlocationsearch_fv");
	if ($bvelem.length > 0 && $bvelem.val() !== "")
	{
		return false;
	}
	if (navigator.geolocation) {
		/* geolocation is available */
		try {
			navigator.geolocation.getCurrentPosition(successLocation, failureLocation);
		}
		catch (e) {
			// May not work!
			return false;
		}
	}
}


var geolocationSupport = {
	setup: function () {
		if (navigator.geolocation) {
			navigator.geolocation.getCurrentPosition(
				function (position) {

					// Did we get the position correctly?
					alert(position.coords.latitude);

					// To see everything available in the position.coords array:
					for (key in position.coords) {
						alert(key)
					}

					mapServiceProvider(position.coords.latitude, position.coords.longitude);

				},
				// next function is the error callback
				function (error) {
					switch (error.code) {
						case error.TIMEOUT:
							alert('Timeout');
							break;
						case error.POSITION_UNAVAILABLE:
							alert('Position unavailable');
							break;
						case error.PERMISSION_DENIED:
							alert('Permission denied');
							break;
						case error.UNKNOWN_ERROR:
							alert('Unknown error');
							break;
					}
				}
			);
		}
	}

}


window.addEventListener('load' ,function () {
	try {
		// Load ahead of time to make sure its loaded
		if (typeof geomapsprovider == "undefined" || geomapsprovider == "googlemaps") {
			myGeocoder = new google.maps.Geocoder();
		}

		// set the form onsubmit event
		var myform = document.getElementById("jeventspost");
		if (myform.length > 0) {
			myform.addEventListener("submit", function (eventObj) {
				if (skipGeoLookup)
				{
					return true;
				}
				var gvelem = document.getElementById("geosearch_fv");
				if (gvelem.length == 0)
				{
					gvelem = document.getElementById("browserlocationsearch_fv");
				}
				// if auto geolocating then we have the address and longitude/latitude already
				if (gvelem.length > 0 && gvelem.nodeValue != "") {
					return true;
				}

				var googleaddress = document.getElementById("googleaddress");
				if (googleaddress.length > 0) {
					googleaddress = googleaddress.nodeValue;
				}
				// force submit to wait for the address to be checked
				if (googleaddress && googleaddress.length > 0) {
					eventObj.preventDefault();
					eventObj.stopImmediatePropagation();

					findAddressGeo(eventObj, 1);
				}
			});

		}
	}
	catch (e) {

	}
});
