<?php
defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Language\Text;

$compparams = ComponentHelper::getParams("com_jevlocations");
$usecats = $compparams->get("usecats", 0);
?>
<div id="jevents" >
    <!-- CONTENT -->
    <div class="gsl-container gsl-container-expand">
        <div class="gsl-grid gsl-grid-divider gsl-grid-medium gsl-child-width-1-2 gsl-child-width-1-3@m gsl-child-width-1-4@l"
             gsl-grid>
            <div>
                <span class="gsl-text-small">
                        <span gsl-icon="icon:location" class="gsl-margin-small-right gsl-text-primary"></span>
                        <?php echo Text::_("COM_JEVLOCATIONS_TOTAL_VENUES");?>
                </span>
                <h2 class="gsl-heading-primary gsl-margin-remove gsl-text-primary">
                    <a href="<?php echo Route::_("index.php?option=com_jevlocations&task=locations.overview")?>">
						<?php echo $this->totalvenues;?>
                    </a>
                </h2>
            </div>
            <?php
            if ($usecats)
            {
	            ?>
                <div>
                <span class="gsl-text-small">
                        <span gsl-icon="icon:world"
                              class="gsl-margin-small-right gsl-text-primary"></span>
                        <?php echo Text::_("COM_JEVLOCATIONS_TOTAL_LOCATION_CITES_STATES_COUNTRIES"); ?>
                </span>
                    <h2 class="gsl-heading-primary gsl-margin-remove gsl-text-primary">
                        <a href="<?php echo Route::_("index.php?option=com_jevlocations&task=categories.list") ?>">
				            <?php echo $this->totalcsc; ?>
                        </a>
                    </h2>
                </div>
	            <?php
            }
            ?>
            <div>
                <span class="gsl-text-small">
                        <span gsl-icon="icon:thumbnails"
                              class="gsl-margin-small-right gsl-text-primary"></span>
                        <?php echo Text::_("COM_JEVLOCATIONS_TOTAL_LOCATION_CATEGORIES");?>
                </span>
                <h2 class="gsl-heading-primary gsl-margin-remove gsl-text-primary">
                    <a href="<?php echo Route::_("index.php?option=com_categories&extension=com_jevlocations")?>">
						<?php echo $this->totalcategories;?>
                    </a>
                </h2>
            </div>
        </div>
    </div>

    <hr>
    <div class="gsl-grid gsl-grid-medium" gsl-grid>
        <!-- panel -->
		<?php
		// Must load admin language files
		$lang = Factory::getLanguage();
		$lang->load("com_jevents", JPATH_ADMINISTRATOR);
		?>

        <div class="gsl-width-1-4">
            <div class="gsl-card gsl-card-default gsl-card-small gsl-card-hover">
                <div class="gsl-card-header">
                    <div class="gsl-grid gsl-grid-small">
                        <div class="gsl-width-auto gsl-align-center gsl-margin-remove-bottom"><h4><?php echo Text::_("COM_JEVLOCATIONS");?></h4></div>
                    </div>
                </div>
                <div class="gsl-card-body">
                    <a class="gsl-button gsl-align-center" href="index.php?option=com_jevlocations&task=locations.overview">
                        <span gsl-icon="icon:location; ratio: 3;"></span>
                    </a>
                </div>
            </div>
        </div>

        <div class="gsl-width-1-4">
            <div class="gsl-card gsl-card-default gsl-card-small gsl-card-hover">
                <div class="gsl-card-header">
                    <div class="gsl-grid gsl-grid-small">
                        <div class="gsl-width-auto gsl-align-center gsl-margin-remove-bottom"><h4><?php echo Text::_("COM_JEVLOCATIONS_LOCATION_CATEGORIES");?></h4></div>
                    </div>
                </div>
                <div class="gsl-card-body">
                    <a class="gsl-button  gsl-align-center" href="index.php?option=com_categories&extension=com_jevlocations">
                        <span gsl-icon="icon:thumbnails; ratio: 3;"></span>
                    </a>
                </div>
            </div>
        </div>

        <?php
        if ($usecats)
        {
	        ?>
        <div class="gsl-width-1-4">
            <div class="gsl-card gsl-card-default gsl-card-small gsl-card-hover">
                <div class="gsl-card-header">
                    <div class="gsl-grid gsl-grid-small">
                        <div class="gsl-width-auto gsl-align-center gsl-margin-remove-bottom"><h4><?php echo Text::_("COM_JEVLOCATIONS_COUNTRY_STATE_CITY");?></h4></div>
                    </div>
                </div>
                <div class="gsl-card-body ">
                    <a class="gsl-button  gsl-align-center" href="index.php?option=com_jevlocations&task=categories.list">
                        <span gsl-icon="icon:world; ratio: 3;"></span>
                    </a>
                </div>
            </div>
        </div>
	    <?php
        }
        ?>

        <div class="gsl-width-1-4">
            <div class="gsl-card gsl-card-default gsl-card-small gsl-card-hover">
                <div class="gsl-card-header">
                    <div class="gsl-grid gsl-grid-small">
                        <div class="gsl-width-auto gsl-align-center gsl-margin-remove-bottom"><h4><?php echo Text::_("JEV_LAYOUT_DEFAULTS");?></h4></div>
                    </div>
                </div>
                <div class="gsl-card-body">
                    <a class="gsl-button  gsl-align-center" href="index.php?option=com_jevents&task=defaults.list&filter_layout_type=jevlocations">
                        <span gsl-icon="icon:file-edit; ratio: 3;"></span>
                    </a>
                </div>
            </div>
        </div>

    </div>

    <form action="<?php echo Route::_('index.php?option=com_jevlocations'); ?>" method="post" name="adminForm" id="adminForm">
        <input type="hidden" name="task" value=""/>
        <input type="hidden" name="redirecturl" value=""/>
        <input type="hidden" name="boxchecked" value="0"/>
        <input type="hidden" name="form_submitted" value="1"/>
        <input type="hidden" name="baseurl" id="baseurl" value="<?php echo JURI::root(); ?>"/>
        <input type="hidden" name="listlayout" id="listlayout"  value=""/>
        <input type="hidden" id="ystscomponent" value="dashboard"/>
        <input type="hidden" name="option" value="<?php echo JEVEX_COM_COMPONENT; ?>" />
		<?php echo HTMLHelper::_('form.token', array('id' => "tokenid")); ?>
    </form>
</div>
