<?php
/**
 * copyright (C) 2008 GWE Systems Ltd - All rights reserved
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC' ) or die();

use Joomla\Registry\Registry;
use Joomla\CMS\Access\Access;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Filter\OutputFilter;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Filesystem\File;
use Joomla\CMS\Filesystem\Folder;
use Joomla\String\StringHelper;

jimport('joomla.application.component.view');
jimport('joomla.html.parameter');

/**
 * HTML View class for the component
 *
 * @static
 */
class AdminLocationsViewLocations extends JevlocationsAbstractView
{
	public $location;
	public $locations;
	public $locparams;
	public $mediaData;
	public $maxOwnLocationsReached = false;

	function overview($tpl = null)
	{
		HTMLHelper::_('bootstrap.framework');

		$user      = Factory::getUser();

		$option = JEVEX_COM_COMPONENT;
		$mainframe = Factory::getApplication();  // RSH 10/11/10 - make 1.5/1.6 compatible

        $jinput = $mainframe->input;
        $tmpl   = $jinput->getString('tmpl', 0);


		if (version_compare(JVERSION, '3.0', ">="))
		{
			HTMLHelper::stylesheet('com_jevlocations/jevlocations3x.css', array(), true);
		}
		else
		{
			JHTML::stylesheet('administrator/components/com_jevlocations/assets/css/jevlocations.css');
		}

		JHTML::stylesheet('administrator/components/com_jevlocations/assets/css/eventsadmin.css');

		// Lets check if we have editted before! if not... rename the custom file.
		if (File::exists(JPATH_SITE . "/components/com_jevents/assets/css/jevcustom.css"))
		{
			// It is definitely now created, lets load it!
			JEVHelper::stylesheet('jevcustom.css', 'components/' . JEV_COM_COMPONENT . '/assets/css/');
		}

		// Get the toolbar object instance
		$bar = JToolBar::getInstance('toolbar');

		// Set toolbar items for the page
		JToolBarHelper::title(Text::_('Locations_Manager'), 'jevlocations');
		JToolBarHelper::addNew("locations.edit");
		JToolBarHelper::editList("locations.edit");
		JToolBarHelper::publishList("locations.publish");
		JToolBarHelper::unpublishList("locations.unpublish");
		JToolBarHelper::deleteList("Are you sure you want to delete these locations?", "locations.delete");
        JToolbarHelper::checkin('locations.checkin');

		if ($tmpl === "component")
		{
			JToolBarHelper::custom("locations.select", "back", "back", "JEV_BACK_TO_SELECT", false);
		}
		//JToolBarHelper::help( 'screen.locations' );
		if ($mainframe->isClient('administrator') && $tmpl !== "component")
		{
			JToolBarHelper::cancel('cpanel.cpanel', 'Control Panel');
		}

		//$this->showToolBar();
		JevlocationsHelper::addSubmenu();

		$document = Factory::getDocument();

		if ($mainframe->isClient('site') && $tmpl !== "component")
		{
			$menu = Factory::getApplication('site')->getMenu()->getActive();
			if($menu && isset($menu->params) && !is_null($menu->params))
			{
				$pageTitle = $menu->params->get('page_title', Text::_('JEVENTS_JEVENTS_LOCATION_MANAGER') . ' :: ' . Text::_('LOCATIONS'));
			} else {
				$pageTitle = Text::_('JEVENTS_JEVENTS_LOCATION_MANAGER') . ' :: ' . Text::_('LOCATIONS');
			}
		}
		else
		{
			$pageTitle = Text::_('JEVENTS_JEVENTS_LOCATION_MANAGER') . ' :: ' . Text::_('LOCATIONS');
		}

		$document = Factory::getDocument();
		$document->setTitle($pageTitle);

		$filter_state = $mainframe->getUserStateFromRequest($option . 'loc_filter_state', 'filter_state', '', 'word');
		$filter_creator = $mainframe->getUserStateFromRequest($option . 'loc_filter_created_by', 'filter_created_by', '', 'email');
		$filter_catid = $mainframe->getUserStateFromRequest($option . 'loc_filter_catid', 'filter_catid', 0, 'int');
		$filter_loccat = $mainframe->getUserStateFromRequest($option . 'loc_filter_loccat', 'filter_loccat', 0, 'int');
		$filter_priority = $mainframe->getUserStateFromRequest($option . 'loc_filter_priority', 'filter_priority', 0, 'int');

		$filter_order = $mainframe->getUserStateFromRequest($option . 'loc_filter_order', 'filter_order', 'loc.ordering', 'cmd');
		$filter_order_Dir = $mainframe->getUserStateFromRequest($option . 'loc_filter_order_Dir', 'filter_order_Dir', '', 'word');
		$search = $mainframe->getUserStateFromRequest($option . 'loc_search', 'search', '', 'string');
		$search = StringHelper::strtolower($search);

		// Get data from the model
		$params         = ComponentHelper::getParams('com_jevents');
		$compparams     = ComponentHelper::getParams('com_jevlocations');
		$authorisedonly = $params->get("authorisedonly", 0);
		$juser          = Factory::getUser();

		if ($authorisedonly)
		{
			Factory::getApplication()->input->set("showglobal", $this->jevuser && $this->jevuser->cancreateglobal);
		}
		else
		{
			$loc_global = $compparams->get("loc_global", 24);

			if (version_compare(JVERSION, "1.6.0", 'ge'))
			{
				if ($juser->authorise('core.createglobal', 'com_jevlocations') && $juser->authorise('core.edit', 'com_jevlocations'))
				{
					Factory::getApplication()->input->set("showglobal", 1);
				}
				else
				{
					Factory::getApplication()->input->set("showglobal", 0);
				}
			}
			else
			{
				if ($juser->gid >= intval($loc_global))
				{
					Factory::getApplication()->input->set("showglobal", 1);
				}
				else
				{
					Factory::getApplication()->input->set("showglobal", 0);
				}
			}
		}
		if (JEVHelper::isAdminUser($juser))
		{
			Factory::getApplication()->input->set("showall", 1);
		}
		$model =  $this->getModel();
		$total =  $this->get('Total');
		$items =  $this->get('Data');
		$pagination =  $this->get('Pagination');

		// New custom fields
		JevLocationsHelper::getLocationsCustomFields($items);

		$compparams = ComponentHelper::getParams("com_jevlocations");
		$template = $compparams->get("fieldtemplate", "");
		$cfarray = array();
		if ($template != "" && $compparams->get("custinlist") && PluginHelper::isEnabled("jevents", 'jevcustomfields')) {
			$xmlfile = JPATH_SITE . "/plugins/jevents/jevcustomfields/customfields/templates/" . $template;
			if (file_exists($xmlfile)) {
				JLoader::register('JevCfForm', JPATH_SITE . "/plugins/jevents/jevcustomfields/customfields/jevcfform.php");
				$jcfparams = JevCfForm::getInstance("com_jevlocations.customfields", $xmlfile, array('control' => 'jform', 'load_data' => true), true, "/form");
				$customfields = array();
				$groups = $jcfparams->getFieldsets();
				foreach ($groups as $group => $element) {
					$fsparams = $jcfparams->getFieldset($group);

					if ($fsparams) {
						foreach ($fsparams as $p => $node) {
							$nodename = $node->attribute('name');
							$nodelabel = $node->attribute('label');
							if ($nodelabel && $nodename) {
								$cfarray[$nodename] = Text::_($nodelabel);
							}
						}
					}
				}
			}
		}

		// build list of categories
		$javascript = 'onchange="document.adminForm.submit();"';
		$usecats = $compparams->get("usecats", 0);
		JLoader::register('JevLocationsHTML', JPATH_ADMINISTRATOR . "/components/com_jevlocations/libraries/jevlocationshtml.php");
		if ($usecats)
		{
			$lists['catid'] = JevLocationsHTML::buildCategorySelect(intval($filter_catid), $javascript, "", false, false, 0, 'filter_catid', 'com_jevlocations');
			$lists['catid'] = str_replace(Text::_('COM_JEVLOCATIONS_ALL_CATEGORIES'), Text::_("COM_JEVLOCATIONS_ALL_CITIES"), $lists['catid']);
		}
		// normal category filter
		$lists['loccat'] = JevLocationsHTML::buildCategorySelect2(intval($filter_loccat), $javascript, "", false, false, 0, 'filter_loccat', 'com_jevlocations',false,"ordering",false);
		// state filter
		$lists['state'] = HTMLHelper::_('grid.state', $filter_state);
		// creator filter
		$lists['creator'] = JevLocationsHTML::buildCreatorSelect($filter_creator);

		// table ordering
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;

		$priorities = "";
		// only those who can publish globally can set priority field
		if (JEVHelper::isEventPublisher(true))
		{
			$list = array();
			for ($i = 0; $i < 10; $i++)
			{
				$list[] = HTMLHelper::_('select.option', $i, $i, 'val', 'text');
			}
			$priorities = HTMLHelper::_('select.genericlist', $list, 'filter_loccat', "", 'val', 'text', intval($filter_priority));
			$this->setPriority = true;
			$lists["priority"] = $priorities;
		}
		else
		{
			$this->setPriority = false;
			$lists["priority"] = $priorities;
		}

		// search filter
		$lists['search'] = $search;

		$user = Factory::getUser();
		$this->user = $user;
		$this->usecats = $usecats;
		$this->lists = $lists;
		$this->items = $items;
		$this->pagination = $pagination;
		$this->mainframe = $mainframe;

	}

	function select($tpl = null)
	{
		JLoader::register('JevModal',JPATH_LIBRARIES."/jevents/jevmodal/jevmodal.php");

		// Include jQuery framework
		HTMLHelper::_('jquery.framework');
		HTMLHelper::_('bootstrap.framework');
		//HTMLHelper::_('bootstrap.loadCss');

		HTMLHelper::script('com_jevents/jevmaps/locationdetail.js', array('version' => JeventsHelper::JEvents_Version(false), 'relative' => true));
		HTMLHelper::script('com_jevlocations/locations.js', array('version' => JeventsHelper::JEvents_Version(false), 'relative' => true));

		JLoader::register('JEventsHTML', JPATH_SITE . "/components/com_jevents/libraries/jeventshtml.php");

		$option = JEVEX_COM_COMPONENT;
		$mainframe = Factory::getApplication();  // RSH 10/11/10 - make 1.5/1.6 compatible

		if (version_compare(JVERSION, '3.0', ">=")){
			HTMLHelper::stylesheet('com_jevlocations/jevlocations3x.css',array(),true);
		} else {
			JHTML::stylesheet( 'administrator/components/com_jevlocations/assets/css/jevlocations.css');
		}
		JHTML::stylesheet('administrator/components/com_jevlocations/assets/css/eventsadmin.css');
		// Lets check if we have editted before! if not... rename the custom file.
		if (File::exists(JPATH_SITE . "/components/com_jevents/assets/css/jevcustom.css"))
		{
			// It is definitely now created, lets load it!
			JEVHelper::stylesheet('jevcustom.css', 'components/' . JEV_COM_COMPONENT . '/assets/css/');
		}

		// Set toolbar items for the page
		JToolBarHelper::title(Text::_('COM_JEVLOCATIONS_SELECT_LOCATION'), 'jevlocations');

		// Only offer management buttons if use is authorised
		if (JevLocationsHelper::canCreateOwn() || JevLocationsHelper::canCreateGlobal())
		{
			//JToolBarHelper::addNew("locations.edit","Create Location");
			$this->toolbarButton("locations.edit", "new", "new", "Create_Location", false);
		}
		if (JevLocationsHelper::canCreateOwn())
		{
			$this->toolbarButton("locations.overview", "config", "config", "Manage_Locations", false);
		}

		//$this->showToolBar();

		$document = Factory::getDocument();
		$document->setTitle(Text::_('JEVENTS_JEVENTS_LOCATION_MANAGER') . ' :: ' . Text::_('LOCATIONS'));

		$filter_loctype = $mainframe->getUserStateFromRequest($option . 'loc_filter_loctype', 'filter_loctype', 0, 'int');
		$filter_catid = $mainframe->getUserStateFromRequest($option . 'loc_filter_catid', 'filter_catid', 0, 'int');
		$filter_loccat = $mainframe->getUserStateFromRequest($option . 'loc_filter_loccat', 'filter_loccat', 0, 'int');
		$filter_priority = $mainframe->getUserStateFromRequest($option . 'loc_filter_priority', 'filter_priority', 0, 'int');

		$filter_order = $mainframe->getUserStateFromRequest($option . 'loc_filter_order', 'filter_order', 'loc.ordering', 'cmd');
		$filter_order_Dir = $mainframe->getUserStateFromRequest($option . 'loc_filter_order_Dir', 'filter_order_Dir', '', 'word');
		$search = $mainframe->getUserStateFromRequest($option . 'loc_search', 'search', '', 'string');
		$search = StringHelper::strtolower($search);

		// Should we be allowed to select from all locations?
		$compparams = ComponentHelper::getParams("com_jevlocations");
		Factory::getApplication()->input->set("showall", $compparams->get("selectfromall", 0));
		// JEvents admin users can see them all
		$juser =  Factory::getUser();
		if (JEVHelper::isAdminUser($juser))
		{
			Factory::getApplication()->input->set("showall", 1);
		}

		// Get data from the model
		$model =  $this->getModel();
		$model->setState("select", true);
		$model->setState("loctype", $filter_loctype);

		$total =  $this->get('Total');
		$items =  $this->get('Data');
		$pagination =  $this->get('Pagination');

		// New custom fields

		JevLocationsHelper::getLocationsCustomFields($items);

		$template = $compparams->get("fieldtemplate", "");

		$cfarray = array();

		if ($template != "" && $compparams->get("custinlist") && PluginHelper::isEnabled("jevents", 'jevcustomfields')) {
			$xmlfile = JPATH_SITE . "/plugins/jevents/jevcustomfields/customfields/templates/" . $template;
			if (file_exists($xmlfile)) {
				JLoader::register('JevCfForm', JPATH_SITE . "/plugins/jevents/jevcustomfields/customfields/jevcfform.php");
				$jcfparams = JevCfForm::getInstance("com_jevlocations.customfields", $xmlfile, array('control' => 'jform', 'load_data' => true), true, "/form");
				$customfields = array();
				$groups = $jcfparams->getFieldsets();
				foreach ($groups as $group => $element) {
					$fsparams = $jcfparams->getFieldset($group);
					if ($fsparams) {
						foreach ($fsparams as $p => $node) {
							$nodename = $node->attribute('name');
							$nodelabel = $node->attribute('label');
							if ($nodelabel && $nodename) {
								$cfarray[$nodename] = Text::_($nodelabel);
							}
						}
					}
				}
			}
		}


		// build list of categories
		$usecats = $compparams->get("usecats", 0);
		$javascript = 'onchange="document.adminForm.submit();"';
		JLoader::register('JevLocationsHTML', JPATH_ADMINISTRATOR . "/components/com_jevlocations/libraries/jevlocationshtml.php");
		if ($usecats)
		{
			$lists['catid'] = JevLocationsHTML::buildCategorySelect(intval($filter_catid), $javascript, "", false, false, 0, 'filter_catid', 'com_jevlocations');
			$lists['catid'] = str_replace(Text::_('COM_JEVLOCATIONS_ALL_CATEGORIES'), Text::_("COM_JEVLOCATIONS_ALL_CITIES"), $lists['catid']);
		}
		// normal category filter
		$lists['loccat'] = JevLocationsHTML::buildCategorySelect2(intval($filter_loccat), $javascript, "", false, false, 0, 'filter_loccat', 'com_jevlocations',false,"ordering",false);

		$options = array();
		$options[] = HTMLHelper::_('select.option', 0, Text::_('COM_JEVLOCATIONS_ANY_LOCATION'));
		$options[] = HTMLHelper::_('select.option', 1, Text::_('COM_JEVLOCATIONS_MY_LOCATIONS'));
		$options[] = HTMLHelper::_('select.option', 2, Text::_('COM_JEVLOCATIONS_COMMON_LOCATIONS'));
		$lists["loctype"] = HTMLHelper::_('select.genericlist', $options, 'filter_loctype', 'class="inputbox" size="1" onchange="form.submit();"', 'value', 'text', $filter_loctype);

		// only those who can publish globally can set priority field
		if (JEVHelper::isEventPublisher(true))
		{
			$list = array();
			for ($i = 0; $i < 10; $i++)
			{
				$list[] = HTMLHelper::_('select.option', $i, $i, 'val', 'text');
			}
			$priorities = HTMLHelper::_('select.genericlist', $list, 'filter_loccat', "", 'val', 'text', intval($filter_priority));
			$this->setPriority =  true;
			$lists["priority"] = $priorities;
		}
		else
		{
			$this->setPriority =  false;
			$lists["priority"] = "";
		}

		// table ordering
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;

		// search filter
		$lists['search'] = $search;

		$user = Factory::getUser();
		$this->user = $user;
		$this->usecats = $usecats;
		$this->lists = $lists;
		$this->items = $items;
		$this->pagination = $pagination;


	}

	function edit($tpl = null)
	{
		// Include jQuery framework
		HTMLHelper::_('jquery.framework');
		HTMLHelper::_('bootstrap.framework');

		JLoader::register('JEventsHTML', JPATH_SITE . "/components/com_jevents/libraries/jeventshtml.php");
		JLoader::register('jevlocationsCategory', JPATH_COMPONENT_ADMINISTRATOR . "/libraries/categoryClass.php");

		$option = JEVEX_COM_COMPONENT;
		$mainframe = Factory::getApplication();
		$compparams = ComponentHelper::getParams("com_jevlocations");
		$allowed = true;

		HTMLHelper::stylesheet('com_jevlocations/jevlocations3x.css', array(), true);
		JHTML::stylesheet('administrator/components/com_jevlocations/assets/css/eventsadmin.css');

		// Lets check if we have editted before! if not... rename the custom file.
		if (File::exists(JPATH_SITE . "/components/com_jevents/assets/css/jevcustom.css"))
		{
			// It is definitely now created, lets load it!
			JEVHelper::stylesheet('jevcustom.css', 'components/' . JEV_COM_COMPONENT . '/assets/css/');
		}

		// Get the location
		$location = $this->get('data');
		$isNew = ($location->loc_id < 1);

		// Set toolbar items for the page
		$text = $isNew ? Text::_('COM_JEVLOCATIONS_NEW') : Text::_('COM_JEVLOCATIONS_EDIT');
		JToolBarHelper::title(Text::_('COM_JEVLOCATIONS_LOCATION') . ': <small><small>[ ' . $text . ' ]</small></small>', 'jevlocations');

		JToolbarHelper::apply('locations.apply');
		JToolbarHelper::save('locations.save');

		if ($isNew)
		{
			JToolbarHelper::cancel('locations.cancel');

			$ownLocationsLimit = $compparams->get('max_art');

			if ($ownLocationsLimit > 0)
			{
				if (JevLocationsHelper::userReachedMaxOwnLocations())
				{
					$this->maxOwnLocationsReached = true;

					if (JevLocationsHelper::canCreateGlobal())
					{
						$msg = Text::_('COM_JEVLOCATIONS_NEW_LOCATION_MAX_OWN_LOCATIONS_ONLY_GLOBAL_WARNING');
						Factory::getApplication()->enqueueMessage($msg, 'warning');
					}
					else
					{
						$msg = Text::_('COM_JEVLOCATIONS_NEW_LOCATION_MAX_OWN_LOCATIONS_CANT_CREATE_WARNING');
						Factory::getApplication()->enqueueMessage($msg, 'error');
						$allowed = false;
					}
				}
			}
		}
		else
		{
			// To Do for Next release: Save as New/Copy button
			JToolbarHelper::save2copy('locations.savecopy', "JTOOLBAR_SAVE_AS_COPY");

			// For existing items the button is renamed `close`
			JToolbarHelper::cancel('locations.cancel', "JTOOLBAR_CLOSE");
		}

		if ($allowed)
		{
			//$this->showToolBar();

			$document = Factory::getDocument();

			$document->setTitle(Text::_('JEVENTS_JEVENTS_LOCATION_MANAGER') . ' :: ' . Text::_('EDIT_LOCATION'));

			$option = JEVEX_COM_COMPONENT;

			$user = Factory::getUser();
			$model = $this->getModel();

			$lists = array();

			$mapsprovider = $compparams->get("mapsprovider", "googlemaps");
			$editdata = $compparams->get($mapsprovider . '-on_edit', false);

			if ($isNew || ($location->geolon == 0 && $location->geolat == 0))
			{
				$location->geolon  = $long = $editdata && isset($editdata->longitude) && !empty($editdata->longitude) ?
					$editdata->longitude : $compparams->get('long', 30);
				$location->geolat  = $lat  = $editdata && isset($editdata->latitude) && !empty($editdata->latitude) ?
					$editdata->latitude : $compparams->get('lat', 30);
				$location->geozoom = $zoom = $editdata && isset($editdata->zoom) && !empty($editdata->zoom) ?
					$editdata->zoom : $compparams->get('zoom', 10);

			}
			else
			{
				$long = $location->geolon;
				$lat = $location->geolat;
				$zoom = $location->geozoom;
			}


			if ($mapsprovider == "googlemaps")
			{
				$maptype = JevLocationsHelper::getParameter('googlemaps-lookandfeel', "maptype", "ROADMAP");

				$script = "var urlrootloc = '" . JURI::root() . "media/com_jevlocations/images/';\n";
				$script .= <<<SCRIPT
var globallong = $long;
var globallat = $lat;
var globalzoom = $zoom;
var mapsprovider = "$mapsprovider";

var maptype = "$maptype";
var mapicon = "$location->mapicon" || "blue-dot.png";

document.addEventListener('DOMContentLoaded', function() {
	myMapload(true);
});

SCRIPT;
				$document->addScriptDeclaration($script);

			}
			else
			{

				$mapquestkey = JevLocationsHelper::getParameter('openstreetmaps-service', "mapquestkey", "");
				$script = "var urlrootloc = '" . JURI::root() . "media/com_jevlocations/images/';\n";
				$script .= <<<SCRIPT
var globallong = $long;
var globallat = $lat;
var globalzoom = $zoom;
var mapsprovider = "$mapsprovider";
var mapquestkey = "$mapquestkey";
var mapicon = "blue-dot.png";

document.addEventListener('DOMContentLoaded', function() {
	myMapload(true);
});

SCRIPT;
				$document->addScriptDeclaration($script);
			}

			HTMLHelper::script('com_jevents/jevmaps/locationdetail.js', array('version' => JeventsHelper::JEvents_Version(false), 'relative' => true));
			HTMLHelper::script('com_jevlocations/locations.js', array('version' => JeventsHelper::JEvents_Version(false), 'relative' => true));
			JevLocationsHelper::loadApiScript();

			// Fail if checked out not by 'me'
			if ($model->isCheckedOut($user->get('id')))
			{
				$msg = Text::sprintf('DESCBEINGEDITTED', Text::_('THE_LOCATION'), $location->title);
				$mainframe->redirect('index.php?option=' . $option, $msg);
			}

			// Edit or Create?
			if (!$isNew)
			{
				$model->checkout($user->get('id'));
			}
			else
			{
				// Initialise new record
				$location->published = 1;
				$location->approved = 1;
				$location->order = 0;
				$location->overlaps = 0;
				$location->mapicon = "blue-dot.png";
				$location->catid = Factory::getApplication()->input->post->getInt('catid', 0);
				$location->loccat = Factory::getApplication()->input->post->getInt('loccat', 0);

				if (JevLocationsHelper::canCreateGlobal() && ( $compparams->get("commondefault", 0) || $this->maxOwnLocationsReached ))
				{
					$location->global = 1;
				}

				$location->groupusage = 0;
			}

			// Build the html select list for ordering
			$query = 'SELECT ordering AS value, title AS text'
					. ' FROM #__jev_locations'
					. ' ORDER BY ordering';

			$lists['ordering'] = HTMLHelper::_('list.ordering', 'ordering', $query, "", $location->ordering, $location->loc_id ? 0 : 1);

			if ($compparams->get("groupusage", 0))
			{
				$groups = HTMLHelper::_('user.groups', true);
				$lists['groupusage'] = HTMLHelper::_('select.genericlist', $groups, "groupusage", "", "value", "text", $location->groupusage, "groupusage");
			}

			// List of media files
			jimport("joomla.filesystem.folder");

			$filelist = Folder::files(JPATH_SITE . "/media/com_jevlocations/images/", "\.png");
			$files = array();

			foreach ($filelist as $file)
			{
				$files[] = array("val" => $file, "text" => $file);
			}

			$lists["mapicon"] = HTMLHelper::_('select.genericlist', $files, 'mapicon', "", 'val', 'text', $location->mapicon);

			$usecats = $compparams->get("usecats", 0);

			JLoader::register('JevLocationsHTML', JPATH_ADMINISTRATOR . "/components/com_jevlocations/libraries/jevlocationshtml.php");

			if ($usecats)
			{
				$javascript = "onblur='addressSelected();' ";
				$lists['catid'] = JevLocationsHTML::buildCategorySelect($location->catid, $javascript, "", false, true, 0, 'catid', 'com_jevlocations');
				$lists['catid'] = str_replace(Text::_('JEV_EVENT_CHOOSE_CATEG'), Text::_('CHOOSE_CITY'), $lists['catid']);
			}

			// Normal category filter
			$lists['loccat'] = JevLocationsHTML::buildCategorySelect2($location->catid_list, "", "", false, true, 0, 'loccat[]', 'com_jevlocations',false,"ordering",true);

			// Build the html select list
			$lists['published'] = '<fieldset class="radio btn-grp btn-group">' . HTMLHelper::_('select.booleanlist', 'published', 'class="radio btn"', $location->published) . '</fieldset>';

			include_once JPATH_COMPONENT_ADMINISTRATOR . "/fields/jevmenu.php";
			$node = null;
			$lists['targetmenu'] = str_replace("targetmenu[targetmenu]", "targetmenu", JFormFieldJEVmenu::getInputStatic('targetmenu', $location->targetmenu, $node, 'targetmenu'));

			// Build the html select list
			$globalProperties = array();
			$globalProperties['class'] = "radio btn";

			if ($this->maxOwnLocationsReached)
			{
				$globalProperties['disabled'] = "disabled";
			}

			$lists['global'] = '<fieldset class="radio btn-grp btn-group">'
				. HTMLHelper::_('select.booleanlist', 'global', $globalProperties, $location->global)
				. '</fieldset>';

			$lists['overlaps'] = '<fieldset class="radio btn-grp btn-group">' . HTMLHelper::_('select.booleanlist', 'overlaps', 'class="radio btn"', $location->overlaps) . '</fieldset>';

			// Only those who can publish globally can set priority field
			if (JEVHelper::isEventPublisher(true))
			{
				$list = array();

				for ($i = 0; $i < 10; $i++)
				{
					$list[] = HTMLHelper::_('select.option', $i, $i, 'val', 'text');
				}

				$priorities = HTMLHelper::_('select.genericlist', $list, 'priority', "", 'val', 'text', $location->priority);
				$this->setPriority =  true;
				$this->priority =  $priorities;
			}
			else
			{
				$this->setPriority =  false;
			}


			$recaptcha = array();
			Factory::getApplication()->triggerEvent('onEditLocationCustom', array(&$location, &$recaptcha));

			$this->recaptcha = $recaptcha;

			$this->setCreatorLookup($location);

			// Clean location data
			OutputFilter::objectHTMLSafe($location, ENT_QUOTES, 'description');

			$file = JPATH_COMPONENT . '/models/location.xml';
			$params = new Registry($location->params, $file);

			$this->usecats = $usecats;
			$this->lists = $lists;
			$this->location = $location;
			$this->params = $params;
		}

		$this->allowed = $allowed;

	}

	function detail($tpl = null)
	{
		HTMLHelper::_('jquery.framework');
		JLoader::register('JEventsHTML', JPATH_SITE . "/components/com_jevents/libraries/jeventshtml.php");
		JLoader::register('jevlocationsCategory', JPATH_COMPONENT_ADMINISTRATOR . "/libraries/categoryClass.php");

		JEVHelper::script("components/com_jevents/assets/js/jQnc.js");

		$option = JEVEX_COM_COMPONENT;
		$mainframe = Factory::getApplication();  // RSH 10/11/10 - make 1.5/1.6 compatible
		// Set toolbar items for the page

		$compparams = ComponentHelper::getParams("com_jevlocations");

		//Get Images Sizes
		$mediaSize = new stdClass();
		$mediaSize->thumbnail = array('width' => $compparams->get('thumbw',150), 'height' => $compparams->get('thumbh',150), 'nothumbnail' => $compparams->get('nothumbnail',150));
		$mediaSize->image = array('width' => $compparams->get('imagew',150), 'height' => $compparams->get('thumbh',150));

		$mapsurl = JevLocationsHelper::getMapsUrl();
		JevLocationsHelper::loadApiScript();

		//get the location
		$location =  $this->get('data');

		if (!$location->published)
		{
			$mainframe->redirect('index.php', Text::_("COM_JEVLOCATIONS_NOT_AUTHORISED"));
		}

		//Get Category Data
		$location_categories = $this->getCategoryData();

		$location->categoryData = $location_categories;

		$document = Factory::getDocument();
		$document->setTitle(Text::_('Event_Location') . " :: " . $location->title);

		$subtitle = addslashes(str_replace(" ", "+", urlencode($location->title)));

		$lists = array();

		$long = $location->geolon;
		$lat = $location->geolat;
		$zoom = $location->geozoom;

		$plugin = PluginHelper::getPlugin("jevents", "jevlocations");
		if ($plugin) {
			$pluginparams = new Registry($plugin->params);
		}
		else {
			$pluginparams = new Registry(null);
		}

		if ($compparams->get("gwidth",-1) !=-1){
			$pluginparams = $compparams;
		}

		if ($mapsurl != "")
		{

			$script = "var urlrootloc = '" . JURI::root() . "media/com_jevlocations/images/';\n";
			$maptype = JevLocationsHelper::getParameter('googlemaps-lookandfeel', "maptype", "ROADMAP");
			$disableautopan = $compparams->get("autopan", 1) ? "false" : "true";

			$directionsUrl = $mapsurl . JevLocationsHelper::getDirectionsSlug($lat, $long, $zoom, $subtitle);
			$mapsprovider = $compparams->get("mapsprovider", "googlemaps");

			$script .=<<<SCRIPT
var globallong = $long;
var globallat = $lat;
var globalzoom = $zoom;
var globaltitle = "$subtitle";
var mapsurl = "$mapsurl";
var directionsurl = "$directionsUrl";
var maptype = "$maptype";
var disableautopan = $disableautopan;
var mapicon = "$location->mapicon";
var locurl = "$location->mapicon";


var mapsprovider = "$mapsprovider";

document.addEventListener('DOMContentLoaded', function() {
	myMapload();
});

SCRIPT;

			$document->addScriptDeclaration($script);
		}

		if ($compparams->get("redirecttodirections"))
		{
			$mainframe->redirect($directionsUrl);
			return;
		}

		if ($mapsprovider == "openstreetmaps")
		{
			HTMLHelper::stylesheet("https://unpkg.com/leaflet@1.5.1/dist/leaflet.css");
			HTMLHelper::script("https://unpkg.com/leaflet@1.5.1/dist/leaflet.js");
		}
		else
        {
	        // If we were to use google mutant to displa using leaflet
	        // HTMLHelper::script("https://unpkg.com/leaflet.gridlayer.googlemutant@latest/Leaflet.GoogleMutant.js");
        }

		HTMLHelper::script('com_jevents/jevmaps/locationdetail.js', array('version' => JeventsHelper::JEvents_Version(false), 'relative' => true));

		JevLocationsHelper::getLocationsCustomFields($location);

		if ($compparams->get('usemetatags', false))
		{
			if ($location->metatitle)
			{
				$document->setMetaData('title', $location->metatitle);
			}

			if ($location->metadescription)
			{
				$document->setDescription($location->metadescription);
			}
		}

		$this->location = $location;
		$this->locparams = $compparams;
		$this->mediaData = $mediaSize;


	}

	function toolbarButton($task = '', $icon = '', $iconOver = '', $alt = '', $listSelect = true)
	{
		include_once(JPATH_ADMINISTRATOR . "/components/com_jevents/libraries/jevbuttons.php");
		$bar =  JToolBar::getInstance('toolbar');

		// Add a standard button
		$bar->appendButton('Jev', $icon, $alt, $task, $listSelect);

	}

	function toolbarConfirmButton($task = '', $msg='', $icon = '', $iconOver = '', $alt = '', $listSelect = true)
	{
		include_once(JPATH_ADMINISTRATOR . "/components/com_jevents/libraries/jevbuttons.php");
		$bar =  JToolBar::getInstance('toolbar');

		// Add a standard button
		$bar->appendButton('Jevconfirm', $msg, $icon, $alt, $task, $listSelect);

	}

	function _globalHTML(&$row, $i)
	{

		if (JevLocationsHelper::canCreateGlobal())
		{
			return JevlocationsHelper::toggleActionIcon($row, $i, "locations", "globalise", "privatise", "global", ""  );
		}
		else
		{
			return JevlocationsHelper::fixedActionIcon($row, "global", ""  );
		}

	}

	function _publishedHTML(&$row, $i)
	{
		return JevlocationsHelper::toggleActionIcon($row, $i, "locations", "publish", "unpublish", "published", ""  );
	}

	function showToolBar()
	{
		$mainframe = Factory::getApplication();

		if (!$mainframe->isClient('administrator'))
		{
			?>
			<div class='jevlocations'>
				<div id="toolbar-box" >
					<div class="t">
						<div class="t">
							<div class="t"></div>
						</div>
					</div>
					<div class="m">
						<?php
						$bar =  JToolBar::getInstance('toolbar');
						$barhtml = $bar->render();
						$barhtml = preg_replace('/onclick="(.*)" /', 'onclick="$1;return false;" ', $barhtml);
						//$barhtml = str_replace('href="#"','href="javascript void();"',$barhtml);
						//$barhtml = str_replace('submitbutton','return submitbutton',$barhtml);
						echo $barhtml;

						$mainframe = Factory::getApplication();  // RSH 10/11/10 - make 1.5/1.6 compatible
						$title = $mainframe->JComponentTitle;
						if (!version_compare(JVERSION, "1.6.0", 'ge') || !$mainframe->isClient('administrator'))
						{
							echo $title;
						}
						?>
						<div class="clr"></div>
					</div>
					<div class="b">
						<div class="b">
							<div class="b"></div>
						</div>
					</div>
				</div>
			</div>
			<?php
		}
		// Kepri doesn't load icons etc. when using tmpl=component - but we want them!
		if (Factory::getApplication()->input->getCmd("tmpl", "") == "component" && $mainframe->isClient('administrator'))
		{
			HTMLHelper::stylesheet('administrator/templates/' . $mainframe->getTemplate() . '/css/template.css');
			// Lets check if we have editted before! if not... rename the custom file.
			if (File::exists(JPATH_SITE . "/components/com_jevents/assets/css/jevcustom.css"))
			{
				// It is definitely now created, lets load it!
				JEVHelper::stylesheet('jevcustom.css', 'components/' . JEV_COM_COMPONENT . '/assets/css/');
			}
		}
	}

	protected function setCreatorLookup($row)
	{
		// If user has backend access then allow them to specify the creator
		$user = Factory::getUser();

		if ($user->authorise('core.createforothers', 'com_jevlocations'))
		{
			$params =  ComponentHelper::getParams(JEVEX_COM_COMPONENT);
			$jevparams =  ComponentHelper::getParams(JEV_COM_COMPONENT);
			$authusers = $jevparams->get("authorisedonly", 0);
			if ($authusers)
			{
				$sql = "SELECT u.* FROM #__users AS u LEFT JOIN #__jev_users AS ju ON ju.user_id = u.id WHERE ju.cancreateown = 1 OR ju.cancreateglobal = 1 ORDER BY u.name ASC";
				$db = Factory::getDBO();
				$db->setQuery($sql);
				$users = $db->loadObjectList();
			}
			else
			{
				$db = Factory::getDBO();

				if (version_compare(JVERSION, "1.6.0", 'ge'))
				{
					$rules = Access::getAssetRules("com_jevlocations", true);
					$creatorgroups = $rules->getData();
					// need to merge the arrays because of stupid way Joomla checks super user permissions
					//$creatorgroups = array_merge($creatorgroups["core.admin"]->getData(), $creatorgroups["core.create"]->getData());
					// use union orf arrays sincee getData no longer has string keys in the resultant array
					//$creatorgroups = $creatorgroups["core.admin"]->getData()+ $creatorgroups["core.create"]->getData();
					$creatorgroupsdata = $creatorgroups["core.admin"]->getData();

					// Take the higher permission setting
					foreach ($creatorgroups["core.create"]->getData() as $creatorgroup => $permission)
					{
						if ($permission)
						{
							$creatorgroupsdata[$creatorgroup] = $permission;
						}
					}

					$users = array(0);

					foreach ($creatorgroupsdata as $creatorgroup => $permission)
					{
						if ($permission == 1)
						{
							$users = array_merge(Access::getUsersByGroup($creatorgroup, true), $users);
						}
					}

					$sql = "SELECT * FROM #__users where id IN (" . implode(",", array_values($users)) . ") ORDER BY name asc";
					$db->setQuery($sql);
					$users = $db->loadObjectList();
				}
				else
				{
					$minaccess = $params->getValue("loc_own", 20);
					$sql = "SELECT * FROM #__users WHERE gid >= " . $minaccess . " ORDER BY name ASC";

					$db->setQuery($sql);
					$users = $db->loadObjectList();
				}
			}

			$userOptions[] = HTMLHelper::_('select.option', '-1', 'Select User');

			foreach ($users AS $usr)
			{
				$userOptions[] = HTMLHelper::_('select.option', $usr->id, $usr->name . " ( " . $usr->username . " )");
			}

			if ($row->created_by > 0)
			{
				$creator = $row->created_by;
			}
			elseif ($row->anonname != "" && $row->anonemail != "")
			{
				$creator = -1;
			}
			else
			{
				$creator = $user->id;
			}

			$userlist = HTMLHelper::_('select.genericlist', $userOptions, 'created_by', 'class="inputbox" size="1" ', 'value', 'text', $creator);

			$this->users = $userlist;
		}

	}

	public function getCategoryData()
	{
		static $location_categories;

		if (!isset($location_categories))
		{
			$db	= Factory::getDBO();

			$query = $db->getQuery(true);

			$query->select('c.*');
			$query->from('#__categories AS c');
			$query->where('extension = "com_jevlocations"');
			$query->order('c.lft ASC');

			$db->setQuery($query);
			$location_categories = $db->loadObjectList('id');

			foreach ($location_categories as &$cat)
			{
				$cat->name = $cat->title;
				$params = new Registry($cat->params);
				$cat->color = $params->get("catcolour", "");
				$cat->overlaps = $params->get("overlaps", 0);
				$cat->image = $params->get("image", "");
			}

			unset($cat);


			Factory::getApplication()->triggerEvent('onGetCategoryData', array (& $location_categories));
		}


		Factory::getApplication()->triggerEvent('onGetAccessibleCategories', array (& $location_categories));

		return $location_categories;
	}

}
