<?php
/**
 * copyright (C) 2008 GWE Systems Ltd - All rights reserved
 */

defined( 'JPATH_BASE' ) or die( 'Direct Access to this location is not allowed.' );

use Joomla\CMS\Language\Text;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Factory;

//error_reporting(E_ALL);

jimport('joomla.filesystem.path');

if (isset($_SERVER['HTTP_USER_AGENT']) && (strpos($_SERVER['HTTP_USER_AGENT'], "MSIE") !== false || strpos($_SERVER['HTTP_USER_AGENT'], "Internet Explorer") !== false))
{
	define ("GSLMSIE10" , 1);
}
else
{
	define ("GSLMSIE10" , 0);
}

include_once(JPATH_SITE."/components/com_jevents/jevents.defines.php");
JLoader::register('JevRegistry', JPATH_SITE . "/components/com_jevents/libraries/registry.php");

if (!defined("JEVEX_COM_COMPONENT")){
	define("JEVEX_COM_COMPONENT","com_jevlocations");
	define("JEVEX_COMPONENT",str_replace("com_","",JEVEX_COM_COMPONENT));
}
if (!defined("JEV_COM_COMPONENT")){
	include_once(JPATH_SITE."/components/com_jevents/jevents.defines.php");
}
JLoader::register('JevLocationsHelper',JPATH_ADMINISTRATOR."/components/com_jevlocations/libraries/helper.php");
JLoader::register('JevCfForm',JPATH_SITE."/plugins/jevents/jevcustomfields/customfields/jevcfform.php");
JLoader::register('JevHtmlBootstrap' , JEV_PATH."libraries/bootstrap.php");
JLoader::register('JEVHelper',JPATH_SITE."/components/com_jevents/libraries/helper.php");
JLoader::register('JevLocationsAbstractView',JPATH_COMPONENT_ADMINISTRATOR."/views/abstract/abstract.php");

// load admin language too
$lang 		= Factory::getLanguage();
$lang->load("com_jevlocations", JPATH_ADMINISTRATOR);

// In Joomla 1.6 ComponentHelper::getParams(JEV_COM_COMPONENT) is a clone so the menu params do not propagate so we force this here!
if (version_compare(JVERSION, "1.6.0", 'ge')){
	$newparams	= Factory::getApplication('site')->getParams();
	// Because the application sets a default page title,
	// we need to get it from the menu item itself
	$menu = Factory::getApplication()->getMenu()->getActive();
	if ($menu) {
		$newparams->def('page_heading', $newparams->get('page_title', $menu->title));
	}
	else {
		$params = ComponentHelper::getParams(JEVEX_COM_COMPONENT);
		$newparams->def('page_heading', $params->get('page_title')) ;
	}
	$component = ComponentHelper::getComponent(JEVEX_COM_COMPONENT);
	if ($newparams->get('modlatest_useLocalParam',1) == 0)
	{
		$parametersNames = array("CustFmtStr","Days","DisDateStyle","DisTitleStyle","DispLinks","DispYear",
			"LinkCloaking","LinkToCal","MaxEvents","Mode","NoRepeat","SortReverse","inccss","multiday","useLocalParam");

		foreach($parametersNames as $parameterName)
		{
			$parameterName = "modlatest_".$parameterName;
			$newparams->set($parameterName,$component->params->get($parameterName));
		}
	}
	$component->params = $newparams;
}
$params = ComponentHelper::getParams(JEVEX_COM_COMPONENT);

// Split task into command and task
$cmd = Factory::getApplication()->input->get('task', false);

if (!$cmd) {
	$view =	Factory::getApplication()->input->get('view', "locations");
	$layout = Factory::getApplication()->input->get('layout', "locations");
	if ($view && $layout){
		$cmd = $view.'.'.$layout;
	}
	else $cmd = "locations.locations";
}

if (strpos($cmd, '.') != false) {
	// We have a defined controller/task pair -- lets split them out
	list($controllerName, $task) = explode('.', $cmd);

	// Define the controller name and path
	$controllerName	= strtolower($controllerName);
	$controllerPath	= JPATH_COMPONENT."/".'controllers'."/".$controllerName.'.php';
	$controllerName = "Front".$controllerName;

	// If the controller file path exists, include it ... else lets die with a 500 error
	if (file_exists($controllerPath)) {
		require_once($controllerPath);
	} else {
		throw new Exception( 'Invalid Controller '.$controllerName, 500);
	}
} else {
	// Base controller, just set the task
	$controllerName = $view;
	$task = $layout;
}

// Stop viewing ALL events - it could take VAST amounts of memory
$cfg = JEVConfig::getInstance();
if ($cfg->get('blockall', 0) && ( Factory::getApplication()->input->getInt("limit", -1) == 0 || Factory::getApplication()->input->getInt("limit", -1) > 100 ))
{
	Factory::getApplication()->input->set("limit", 100);
	Factory::getApplication()->setUserState("limit", 100);
}

// Set the name for the controller and instantiate it
$controllerClass = ucfirst($controllerName).'Controller';
if (class_exists($controllerClass)) {
	$controller = new $controllerClass();
} else {
	throw new Exception( 'Invalid Controller Class - '.$controllerClass.(file_exists($controllerPath)?" Exists":" doesnt Exist" ), 500);
}

$config	= Factory::getConfig();

// Perform the Request task
$controller->execute($task);

// Set the browser title to include site name if required
$title =  Factory::getDocument()->GetTitle();
$app = Factory::getApplication();
if (empty($title)) {
	$title = $app->getCfg('sitename');
}
elseif ($app->getCfg('sitename_pagetitles', 0) == 1) {
	$title = Text::sprintf('JPAGETITLE', $app->getCfg('sitename'), $title);
}
elseif ($app->getCfg('sitename_pagetitles', 0) == 2) {
	$title = Text::sprintf('JPAGETITLE', $title, $app->getCfg('sitename'));
}
Factory::getDocument()->SetTitle($title);

// Redirect if set by the controller
$controller->redirect();
