<?php

use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
 
defined('_JEXEC' ) or die('Restricted access');

if (Factory::getApplication()->input->getInt("pop",0)) return;

$compparams = ComponentHelper::getParams("com_jevlocations");

if (!$this->items || count($this->items)==0) return;

JevLocationsHelper::loadApiScript();
HTMLHelper::script('com_jevents/jevmaps/locationdetail.js', array('version' => JeventsHelper::JEvents_Version(false), 'relative' => true));

$task = Factory::getApplication()->input->getString("jevtask","");

$zoom = 10;
$document = Factory::getDocument();
$document->addStyleDeclaration("div.mainlocmap {clear:left;} div#gmapMulti{margin:5px auto} #gmapMulti img { max-width: inherit;}");
$maptype = JevLocationsHelper::getParameter('googlemaps-lookandfeel', "maptype", "ROADMAP");
$disableautopan = $compparams->get("autopan", 1)  ? "false":"true";
$maplinknewwindow = $compparams->get('maplinktonewwindow', '0');
$root = JURI::root();
$Itemid = Factory::getApplication()->input->getInt("Itemid");
$mapsprovider = $compparams->get("mapsprovider", "googlemaps");

$markerlinkinlists = $compparams->get("markerlinkinlists", 'location');

?>
<div class='mainlocmap'>
<?php
ob_start();
?>
    var urlrootloc = '<?php echo JURI::root(); ?>media/com_jevlocations/images/';
    var disableautopan = <?php echo $disableautopan; ?>;
    var maplinknewwindow = <?php echo $maplinknewwindow; ?>;
    var mapsprovider = "<?php echo $mapsprovider;?>";

<?php
$script = ob_get_clean();

$minlon = 0;
$minlat = 0;
$maxlon = 0;
$maxlat = 0;
$first = true;
foreach ($this->items as $location) {
	if ($location->geozoom==0) continue;
	if ($first){
		$minlon = floatval($location->geolon);
		$minlat = floatval($location->geolat);
		$maxlon = floatval($location->geolon);
		$maxlat = floatval($location->geolat);
		$first=false;
	}
	$minlon = floatval($location->geolon)>$minlon?$minlon:floatval($location->geolon);
	$minlat = floatval($location->geolat)>$minlat?$minlat:floatval($location->geolat);
	$maxlon = floatval($location->geolon)<$maxlon?$maxlon:floatval($location->geolon);
	$maxlat = floatval($location->geolat)<$maxlat?$maxlat:floatval($location->geolat);
}
if ($minlon==$maxlon){
	$minlon-=0.002;
	$maxlon+=0.002;
}
if ($minlat==$maxlat){
	$minlat-=0.002;
	$maxlat+=0.002;
}
$midlon = ($minlon + $maxlon)/2.0;
$midlat = ($minlat + $maxlat)/2.0;


$script.=<<<SCRIPT
jQuery(document).ready(function (){window.setTimeout("myMaploadMulti($midlat, $midlon, $minlat, $minlon, $maxlat, $maxlon, '$maptype')",1000);});
function addPoints() {
SCRIPT;

$mapsurl = JevLocationsHelper::getMapsUrl();

foreach ($this->items as $location) {
	if ($location->loc_id==0) continue;
	$title = $location->title;
	// for the description use this
	$description = $location->description;

	if ($markerlinkinlists == 'location')
	{
		$locUrl = Route::_("index.php?option=com_jevlocations&task=locations.detail&se=1&Itemid=" . $Itemid . "&loc_id=" . $location->loc_id);
	}
	else
	{
		$long = $location->geolon;
		$lat = $location->geolat;
		$zoom = $location->geozoom;
		$subtitle = addslashes(str_replace(" ", "+", urlencode($location->title)));
		$locUrl = $mapsurl . JevLocationsHelper::getDirectionsSlug($lat, $long, $zoom, $subtitle);

	}
	// for the address use this
	//$description = $location->street."<br/>".$location->city."<br/>".$location->state."<br/>".$location->postcode."<br/>".$location->country;
	$script.="	addPoint($location->geolat,	$location->geolon, 0, $location->loc_id, '" . addslashes(str_replace(array("\n","\r"),"",$description)) . "', '".addslashes(str_replace("\n","",$title)). "','" . $locUrl."', '".$location->mapicon."', null);\n";
}
$script.="	}";

$document = Factory::getDocument();
$document->addScriptDeclaration($script);

?>
<div id="gmapMulti" style="width: 600px; height:600px;overflow:hidden;"></div>

</div>
